// traffic.cpp : Defines the entry point for the console application.
//
 
 
#include "Stdafx.h"
#include <windows.h>
#include <tchar.h>
#include <stdio.h>
#include <time.h>
#include <strsafe.h>
 
#define       N      1024

extern bool parse_cmd(int);
extern char get_user_cmd(void);
extern bool listen_for_alerts();
extern bool dev_connect();

enum MON_STATE {CONNECTED, DISCONNECTED};

MON_STATE state = DISCONNECTED; 

// the bizarre looking COM path below is a MUST to be able  to access ANY COM port
 
// serial file related
 
HANDLE               hSerial1;
DWORD                dwBytesRead = 0;
DWORD                dwBytesWrite = 0;
char                 nextChar1;
DCB                  dcbSerialParams = {0};
COMMTIMEOUTS  timeouts = {0};
char                 szBuff[N] = {0};
int                  packetLength;
int                        port1;
wchar_t                    comFile1[64];
wchar_t                    *comFile[]  = {      L"\\\\.\\COM0",
                                                       L"\\\\.\\COM1",
                                                       L"\\\\.\\COM2",
                                                       L"\\\\.\\COM3",
                                                       L"\\\\.\\COM4",
                                                       L"\\\\.\\COM5",
                                                       L"\\\\.\\COM6",
                                                       L"\\\\.\\COM7",
                                                       L"\\\\.\\COM8",
                                                       L"\\\\.\\COM9",
                                                       L"\\\\.\\COM10",
                                                       L"\\\\.\\COM11",
                                                       L"\\\\.\\COM12",
                                                       L"\\\\.\\COM13",
                                                       L"\\\\.\\COM14",
                                                       L"\\\\.\\COM15",
                                                       L"\\\\.\\COM16",
                                                       L"\\\\.\\COM17",
                                                       L"\\\\.\\COM18",
                                                       L"\\\\.\\COM19",
                                                       L"\\\\.\\COM20",
                                                       L"\\\\.\\COM21",
                                                       L"\\\\.\\COM22"
                                                };
 
DWORD  baudRates []  = {
                           110,
                           300,
                           600,
                           1200,
                           2400,
                           4800,
                           9600,
                           14400,
                           19200,
                           38400,
                           56000,
                           57600,
                           115200,
                           128000,
                           256000
 
};
 
DWORD  requestedBaudRate = CBR_9600;
                    
 
DWORD  checkBaud(DWORD userBaud) {
       int i;
       int ok;
 
       i = 0;
       ok = 0;
 
       for (i = 0; i < sizeof(baudRates); i++) {
              if (userBaud == baudRates[i]) {
                           ok = 1;
                           break;
              }
       }
 
       if (ok) return userBaud;
       return 9600;
}
 
void DisplayError(LPTSTR lpszFunction)
// Routine Description:
// Retrieve and output the system error message for the last-error code
{
    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;
    DWORD dw = GetLastError();
 
    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL );
 
    lpDisplayBuf =
        (LPVOID)LocalAlloc( LMEM_ZEROINIT,
                            ( lstrlen((LPCTSTR)lpMsgBuf)
                              + lstrlen((LPCTSTR)lpszFunction)
                              + 40) // account for format string
                            * sizeof(TCHAR) );
   
    if (FAILED( StringCchPrintf((LPTSTR)lpDisplayBuf,
                     LocalSize(lpDisplayBuf) / sizeof(TCHAR),
                     TEXT("%s failed with error code %d as follows:\n%s"),
                     lpszFunction,
                     dw,
                     lpMsgBuf)))
    {
        printf("FATAL ERROR: Unable to output error code.\n");
    }
   
    _tprintf(TEXT("ERROR: %s\n"), (LPCTSTR)lpDisplayBuf);
 
    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);
}
 
 
void __cdecl _tmain(int argc, TCHAR *argv[])
{ 
       if (argc != 3) {
                     printf("traffic COM1  baud \n");
                     printf("traffic 10 9600\n");
                     exit(1);
       }
 
      
       port1 = _ttoi(argv[1]);
       wcscpy_s(comFile1, comFile[_ttoi(argv[1])]);
       printf("com1 = %ls\n", comFile1);
       requestedBaudRate = checkBaud(_ttoi(argv[2]));
       printf("requested baud rate = %ld\n", _ttoi(argv[2]));
 
    hSerial1 = CreateFile(comFile1,                                               // file to open
                       GENERIC_READ | GENERIC_WRITE,          // open for reading/writing
                       FILE_SHARE_READ,                                    // share for reading
                       NULL,                                                      // default security
                       OPEN_EXISTING,                                      // existing file only
                       FILE_ATTRIBUTE_NORMAL,                        // normal file
                       NULL);                                                     // no attr. template
    if (hSerial1 == INVALID_HANDLE_VALUE)
    {
        DisplayError(TEXT("CreateFile"));
        _tprintf(TEXT("Terminal failure: unable to open file \"%s\"\n"), comFile1);
              //while (1) {};                   // do this so DOS windows does not disappear
        //return;
    }
 
       dcbSerialParams.BaudRate = requestedBaudRate;
       dcbSerialParams.ByteSize = 8;
       dcbSerialParams.StopBits = ONESTOPBIT;
       dcbSerialParams.Parity = NOPARITY;
 
       if (!SetCommState(hSerial1, &dcbSerialParams)) {
              printf("cant configure \n");
              exit(1);
       }
 
 
       /*
        * TIMEOUT logic control timeout while wating for input
       */
 
       timeouts.ReadIntervalTimeout = 1;
       timeouts.ReadTotalTimeoutMultiplier = 1;
 
       if (!SetCommTimeouts(hSerial1, &timeouts)) {
              printf("cant configure \n");
              exit(1);
       }
 
       // write/read data loop
 
       nextChar1 = 'a';
 
       while (1) {
		   listen_for_alerts();
		   if (state == DISCONNECTED) {
		       if(dev_connect()) {
				   state = CONNECTED;
			   }
		   }
		   parse_cmd(get_user_cmd());
		   
		   Sleep(500);

		   //printf("Cmd = %d\n", get_user_cmd());
		   
		   // Test to see if it will timeout
		   /*
		   if (!ReadFile(hSerial1, szBuff, 1, &dwBytesRead, NULL)) {
               printf("read failed\n");
           }
		   else {
			   printf("Got this size: %d\n", dwBytesRead);
			   for (int i=0; i<dwBytesRead; ++i) {
				      printf("received = %c\n", szBuff[i]);
				}
		   }
		   Sleep(2000);
		   */

		   /*
 
              *szBuff = nextChar1;
             
              if (!WriteFile(hSerial1, szBuff, sizeof(szBuff), &dwBytesWrite, NULL)) {
                     printf("write failed\n");
              }
 
              if (!ReadFile(hSerial1, szBuff, N, &dwBytesRead, NULL)) {
                     printf("read failed\n");
              }
			  else {
				  for (int i=0; i<dwBytesRead; ++i) {
				      printf("received = %c\n", szBuff[i]);
				  }
			  }

			  */
       }
 
       CloseHandle(hSerial1);
}
 
 
